// TrayIcon.h: interface for the CTrayIcon class.
//
//////////////////////////////////////////////////////////////////////

#pragma  once

#include "stdafx.h"
#include <ShellAPI.h>
#include <atlpath.h>
#include <vector>

class CTrayIcon  
{
public:
	CTrayIcon();
	CTrayIcon(HINSTANCE hInstance);
	CTrayIcon(HWND hWnd, UINT uCallbackMessage, LPCTSTR szTip, HICON icon, UINT uID, HINSTANCE hInstance);
	virtual ~CTrayIcon();

	//Create the tray icon
	int Create(HWND hWnd, UINT uCallbackMessage, LPCTSTR szTip, HICON icon, UINT uID);

	//Change or retrieve the Tooltip text
	BOOL    SetTooltipText(LPCTSTR pszTooltipText);
	BOOL    SetTooltipText(UINT nID);
	CString GetTooltipText();

	//Change or retrieve the icon displayed
	BOOL  SetIcon(HICON hIcon);
	BOOL  SetIcon(LPCTSTR lpIconName);
	BOOL  SetIcon(UINT nIDResource);
	BOOL  SetStandardIcon(LPCTSTR lpIconName);
	BOOL  SetStandardIcon(UINT nIDResource);
	HICON GetIcon() const;
	void  RemoveIcon();
	int   Animate();
	void  PopupBalloon(const TCHAR *text, BOOL bShow = TRUE, UINT timeout = 0);

	//Change or retrieve the window to send notification messages to
	BOOL  SetNotificationWnd(HWND hWnd);
	HWND GetNotificationWnd() const;

	void AddIcon(UINT id) { m_IconList.push_back(id); }

// Implementation
protected:
	int	   m_Animate_Number;
	NOTIFYICONDATA	m_tnd;
	HINSTANCE m_hInstance;
	std::vector<UINT> m_IconList; 
};
